/*
 * micro RTX bindings when __NO_INLINE__ (both 16  or 32 bit ints)
 *
 * this file must be compiled **WITHOUT** -fomit-frame-pointer
 * (if you want to compile this with -fomit-frame-pointer, make
 * all the params volatile, and relax "r" constraints with "g")
 *
 *	++jrb	bammi@dsrgsun.ces.cwru.edu
 */

#ifndef __NO_INLINE__
#  define __NO_INLINE__
#endif
#include "grtxbind.h"

long _trap5_w(short n)							
{									
	register long retvalue __asm__("d0");				
	    								
	__asm__ volatile						
	("
		movw    %1,sp@-; 
		trap    #5;	 
		addqw   #2,sp "						
	: "=r"(retvalue)			/* outputs */		
	: "r"(n)				/* inputs  */		
	: "d0", "d1", "d2", "a0", "a1", "a2"    /* clobbered regs */	
	);								
	retvalue;							
}

long _trap5_wl(short n, long l1)					
{									
	register long retvalue __asm__("d0");				
	long  _l1 = (long) (l1);					
	    								
	__asm__ volatile						
	("
 		movl	%2,sp@-; 
		movw    %1,sp@-; 
		trap    #5;	 
		addqw   #6,sp "						
	: "=r"(retvalue)			/* outputs */		
	: "r"(n), "r"(_l1)			/* inputs  */		
	: "d0", "d1", "d2", "a0", "a1", "a2"    /* clobbered regs */	
	);								
	retvalue;							
}

long _trap5_wlw(short n, long l1, short w1)				
{									
	register long retvalue __asm__("d0");				
	long  _l1 = (long) (l1);					
	short _w1 = (short)(w1);					
	    								
	__asm__ volatile						
	("
 		movw	%3,sp@-; 
 		movl	%2,sp@-; 
		movw    %1,sp@-; 
		trap    #5;	 
		addqw   #8,sp "						
	: "=r"(retvalue)			/* outputs */		
	: "r"(n), "r"(_l1), "r"(_w1)		/* inputs  */		
	: "d0", "d1", "d2", "a0", "a1", "a2"    /* clobbered regs */	
	);								
	retvalue;							
}

long _trap5_wlwl(short n, long l1, short w1, long l2)			
{									
	register long retvalue __asm__("d0");				
	long  _l1 = (long) (l1);					
	short _w1 = (short)(w1);					
	long  _l2 = (long) (l2);					
	    								
	__asm__ volatile						
	("
 		movl	%4,sp@-; 
 		movw	%3,sp@-; 
 		movl	%2,sp@-; 
		movw    %1,sp@-; 
		trap    #5;	 
		lea     sp@(12),sp "					
	: "=r"(retvalue)			/* outputs */		
	: "r"(n), "r"(_l1), "r"(_w1), "r"(_l2)	/* inputs  */		
	: "d0", "d1", "d2", "a0", "a1", "a2"    /* clobbered regs */	
	);								
	retvalue;							
}

long _trap5_wll(short n, long l1, long l2)				
{									
	register long retvalue __asm__("d0");				
	long  _l1 = (long) (l1);					
	long  _l2 = (long) (l2);					
	    								
	__asm__ volatile						
	("
 		movl	%3,sp@-; 
 		movl	%2,sp@-; 
		movw    %1,sp@-; 
		trap    #5;	 
		lea     sp@(10),sp "					
	: "=r"(retvalue)			/* outputs */		
	: "r"(n), "r"(_l1), "r"(_l2)		/* inputs  */		
	: "d0", "d1", "d2", "a0", "a1", "a2"    /* clobbered regs */	
	);								
	retvalue;							
}

long _trap5_wlll(short n, long l1, long l2, long l3)			
{									
	register long retvalue __asm__("d0");				
	long  _l1 = (long) (l1);					
	long  _l2 = (long) (l2);					
	long  _l3 = (long) (l3);					
	    								
	__asm__ volatile						
	("
 		movl	%4,sp@-; 
 		movl	%3,sp@-; 
 		movl	%2,sp@-; 
		movw    %1,sp@-; 
		trap    #5;	 
		lea     sp@(14),sp "					
	: "=r"(retvalue)			/* outputs */		
	: "r"(n), "r"(_l1), "r"(_l2), "r"(_l3)	/* inputs  */		
	: "d0", "d1", "d2", "a0", "a1", "a2"    /* clobbered regs */	
	);								
	retvalue;							
}

long _trap5_wwl(short n, short w1, long l1)				
{									
	register long retvalue __asm__("d0");				
	short _w1 = (short)(w1);					
	long  _l1 = (long) (l1);					
	    								
	__asm__ volatile						
	("
 		movl	%3,sp@-; 
 		movw	%2,sp@-; 
		movw    %1,sp@-; 
		trap    #5;	 
		addqw   #8,sp "						
	: "=r"(retvalue)			/* outputs */		
	: "r"(n), "r"(_w1), "r"(_l1)		/* inputs  */		
	: "d0", "d1", "d2", "a0", "a1", "a2"    /* clobbered regs */	
	);								
	retvalue;							
}

long _trap5_wllwl(short n, long l1, long l2, short w1, long l3)		
{									
	register long retvalue __asm__("d0");				
	volatile long  _l1 = (volatile long) (l1);			
	volatile long  _l2 = (volatile long) (l2);			
	volatile short _w1 = (volatile short)(w1);			
	volatile long  _l3 = (volatile long) (l3);			
	    								
	__asm__ volatile						
	("
 		movl	%4,sp@-; 
 		movw	%3,sp@-; 
		movl    %2,sp@-; 
 		movl	%1,sp@-; 
		movw    %0,sp@- "					
	: 						 /* outputs */	
	: "r"(n), "g"(_l1), "g"(_l2), "g"(_w1), "g"(_l3) /* inputs  */	
	);								
	__asm__ volatile						
	("
		trap    #5;	 
		lea     sp@(16),sp "					
	: "=r"(retvalue)				/* outputs */	
	: 						/* inputs  */	
	: "d0", "d1", "d2", "a0", "a1", "a2"    /* clobbered regs */    
	);								
	retvalue;							
}

long _trap5_wlwwlwll( short n, long l1, short w1, short w2, long l2, short w3,
		      long l3, long l4) 
{									
	register long retvalue __asm__("d0");				
	volatile long  _l1 = (volatile long) (l1);			
	volatile short _w1 = (volatile short)(w1);			
	volatile short _w2 = (volatile short)(w2);			
	volatile long  _l2 = (volatile long) (l2);			
	volatile short _w3 = (volatile short)(w3);			
	volatile long  _l3 = (volatile long) (l3);			
	volatile long  _l4 = (volatile long) (l4);			
	    								
	__asm__ volatile						
	("
 		movl	%4,sp@-; 
 		movl	%3,sp@-; 
		movw    %2,sp@-; 
 		movl	%1,sp@-; 
		movw    %0,sp@-"					
	: 						    /* outputs */ 
	: "g"(_w2), "g"(_l2), "g"(_w3), "g"(_l3), "g"(_l4) /* inputs  */ 
	);								
	__asm__ volatile						
	("
 		movw	%3,sp@-; 
 		movl	%2,sp@-; 
		movw    %1,sp@-; 
		trap    #5;	 
		lea     sp@(24),sp "					
	: "=r"(retvalue)			/* outputs */		
	: "r"(n), "g"(_l1), "g"(_w1)		/* inputs  */		
	: "d0", "d1", "d2", "a0", "a1", "a2"    /* clobbered regs */	
	);								
	retvalue;							
}

long _trap5_wwllllll(short n, short w1, long l1, long l2, long l3, long l4,
		     long l5, long l6) 
{									
	register long retvalue __asm__("d0");				
	volatile short _w1 = (volatile short)(w1);			
	volatile long  _l1 = (volatile long) (l1);			
	volatile long  _l2 = (volatile long) (l2);			
	volatile long  _l3 = (volatile long) (l3);			
	volatile long  _l4 = (volatile long) (l4);			
	volatile long  _l5 = (volatile long) (l5);			
	volatile long  _l6 = (volatile long) (l6);			
	    								
	__asm__ volatile						
	("
 		movl	%4,sp@-; 
 		movl	%3,sp@-; 
		movl    %2,sp@-; 
 		movl	%1,sp@-; 
		movl    %0,sp@-"					
	: 						    /* outputs */ 
	: "g"(_l2), "g"(_l3), "g"(_l4), "g"(_l5), "g"(_l6) /* inputs  */ 
	);								
	__asm__ volatile						
	("
 		movl	%3,sp@-; 
 		movw	%2,sp@-; 
		movw    %1,sp@-; 
		trap    #5;	 
		lea     sp@(28),sp "					
	: "=r"(retvalue)			/* outputs */		
	: "r"(n), "g"(_w1), "g"(_l1)		/* inputs  */		
	: "d0", "d1", "d2", "a0", "a1", "a2"    /* clobbered regs */	
	);								
	retvalue;							
}

/*
 * additional gemdos bindings (not in <osbind.h>)
 */
long trap_1_wwwll(short n, short w1, short w2, long l1, long l2)	
{									
	register long retvalue __asm__("d0");				
	volatile short _w1 = (volatile short)(w1);			
	volatile short _w2 = (volatile short)(w2);			
	volatile long  _l1 = (volatile long) (l1);			
	volatile long  _l2 = (volatile long) (l2);			
									
	__asm__ volatile						
	("
		movl    %4,sp@-; 
		movl    %3,sp@-; 
		movw    %2,sp@-; 
		movw    %1,sp@-; 
		movw    %0,sp@- "					
	:					         /* outputs */	
	: "r"(n), "g"(_w1), "g"(_w2), "g"(_l1), "g"(_l2) /* inputs  */	
	);								
	__asm__ volatile						
	("
		trap    #1;	 
		lea    sp@(14),sp" 					
	: "=r"(retvalue)			 /* outputs */		
	: 					/* inputs  */		
	: "d0", "d1", "d2", "a0", "a1", "a2"    /* clobbered regs */    
	);								
	retvalue;							
}
