// This may look like C code, but it is really -*- C++ -*-
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of GNU CC.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY.  No author or distributor
accepts responsibility to anyone for the consequences of using it
or for whether it serves any particular purpose or works at all,
unless he says so in writing.  Refer to the GNU CC General Public
License for full details.

Everyone is granted permission to copy, modify and redistribute
GNU CC, but only under the conditions described in the
GNU CC General Public License.   A copy of this license is
supposed to have been given to you along with GNU CC so you
can know your rights and responsibilities.  It should be in a
file named COPYING.  Among other things, the copyright notice
and this notice must be preserved on all copies.  
*/


#ifndef _std_h
#ifdef __GNUG__
#pragma once
#pragma interface
#endif
#define _std_h 1

#include <stddef.h>
#include <stdio.h>
#include <string.h>
#include <memory.h>
#include <process.h>
#include <unistd.h>
#include <stdlib.h>
#include <signal.h>
#include <termcap.h>

extern "C" {

int       execl(const char*, const char *, ...);
int       execle(const char*, const char *, ...);
int       execlp(const char*, const char*, ...);
int       exect(const char*,  const char**,  char**);
int       execv(const char*,  const char**);
int       execve(const char*, const char**, char**);
int       execvp(const char*,  const char**);
void volatile exit(int);

int       fork(void);

int       isatty(int);
void      swab(void*, void*, int);
int       symlink(const char*, const char*);
int       system(const char*);

}
extern char**   environ;
extern volatile int errno;
extern char*    sys_errlist[];
extern int      sys_nerr;                  
extern char*    optarg;
extern int      opterr;
extern int      optind;


// extern "C" void* alloca(long unsigned int);
#ifndef alloca
#define alloca  __builtin_alloca
#endif
#if !(defined(__GNUG__) || defined(__GNUC__))
extern "C" void *__builtin_alloca (long unsigned int);
#endif


#endif 
