# Makefile for SCM for (Gnu CC port to Atari ST).
# using sozc20's make program under kommando CLI 1.0u
# Copyright (C) 1990, 1991, 1992 Aubrey Jaffer.
# See the file `scm.c' for terms applying to this program

# Pathname where Init.scm resides.  This directory must also contain COPYING.
IMPLINIT=C:\\\\scm\\\\init.scm
# If pathname where Init.scm resides is not known in advance then
# SCM_INIT_PATH is the environment variable whose value is the
# pathname where Init.scm resides.
# IMPLINIT=

CC = cgcc
# -DRTL if this is a run-time library only (no interactive top level)
# -DRECKLESS if you want most scm error checking disabled.
# -O if you want the optimizing C compiler to be used.
FFLAGS=-DFLOATS -DENGNOT
CFLAGS = $(FFLAGS) -O2 -fomit-frame-pointer -fstrength-reduce

# append any names of user extension files
# -lm for -DFLOATS
LIBS = -lpml

# -DINITS= the initialization calls for user extension files.
INITS=-DINITS=init_sc2\(\)\;
FINALS=-DFINALS=\;

#you should not need to change below this line.

#DFLAG = -DIMPLINIT=\"$(IMPLINIT)\"
DFLAG = -DIMPLINIT=\"$(IMPLINIT)\"
ffiles = time.o repl.o scl.o sys.o eval.o subr.o sc2.o unif.o

scm.ttp:	$(ffiles) scm.o
	$(CC) -v -o scm.ttp $(ffiles) scm.o $(LIBS)
scm.o:  scm.c scm.h config.h patchlvl.h
	$(CC) $(CFLAGS) -c $(INITS) scm.c
sys.o:  sys.c scm.h config.h
	$(CC) $(CFLAGS) -c sys.c
scl.o:  scl.c scm.h
	$(CC) $(CFLAGS) -c scl.c
eval.o: eval.c scm.h
	$(CC) $(CFLAGS) -c eval.c
repl.o: repl.c scm.h config.h
	$(CC) $(CFLAGS) -c $(DFLAG) repl.c
time.o: time.c scm.h
	$(CC) $(CFLAGS) -c time.c
subr.o: subr.c scm.h
	$(CC) $(CFLAGS) -c subr.c
sc2.o: sc2.c scm.h
	$(CC) $(CFLAGS) -c sc2.c
unif.o: unif.c scm.h
	$(CC) $(CFLAGS) -c unif.c
install: scm.ttp
	$(CP) scm.ttp C:\bin\scm.ttp
clean:
	$(RM) *.o tmp*
