# Makefile for Texinfo distribution.	-*- Indented-Text -*-
# Atari ST version
# Copyright (C) 1993 Free Software Foundation, Inc.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#### Start of system configuration section. ####

srcdir = .
VPATH  = $(srcdir):$(common)

common = $(srcdir)/libtxi

CC = cgcc
#CC = gcc
RM	= rm -f
STRIP   = xstrip -k $@ # uncomment for a "production" version

RM	= rm -f

DEFS =  -DSTDC_HEADERS=1 -DHAVE_STRING_H=1 -DHAVE_SETVBUF=1 -DHAVE_BZERO=1 \
 -DHAVE_RINDEX=1 -DHAVE_VFPRINTF=1 -DHAVE_VSPRINTF=1 -DHAVE_BCOPY=1 

#if '-mshort' used turn on definition of EXT
MSHORT = #-mshort
EXT = #16

LIBS = 
LOADLIBES = $(LIBS)

ALLOCA = 

CFLAGS = -O2 -fomit-frame-pointer $(MSHORT) -Wall
LDFLAGS = $(MSHORT) -Xlinker -x -v

# Where info files go.
infodir = c:\\gnu\\info
# For info program - pick up your path separator.
PSEP = ,# 
DEFAULT_INFOPATH = .$(PSEP)$(infodir)

#### End of system configuration section. ####

VERSION = 3.1
DISTNAME = texinfo-$(VERSION)

# Subdirectories that have makefiles
SUBDIRS = libtxi makeinfo info util texi2roff

MDEFINES = infodir='$(infodir)' CFLAGS='$(CFLAGS)' \
	CC='$(CC)' ALLOCA='$(ALLOCA)' LDFLAGS='$(LDFLAGS)' \
	DEFAULT_INFOPATH='$(DEFAULT_INFOPATH)' STRIP='$(STRIP)'

all: lb makeinfo.ttp info.ttp texindex.ttp texi2roff.ttp

lb:
	cd libtxi; $(MAKE) -f Makefile.st $(MDEFINES); cd ..

makeinfo.ttp:
	cd makeinfo; $(MAKE) -f Makefile.st $(MDEFINES); cd ..

info.ttp:
	cd info; $(MAKE) -f Makefile.st $(MDEFINES); cd ..

texindex.ttp:
	cd util; $(MAKE) -f Makefile.st $(MDEFINES); cd ..

texi2roff.ttp:
	cd texi2roff; $(MAKE) -f Makefile.st $(MDEFINES); cd ..

clean:
	cd libtxi; $(MAKE) -f Makefile.st $(MDEFINES) $@; cd ..
	cd makeinfo; $(MAKE) -f Makefile.st $(MDEFINES) $@; cd ..
	cd info; $(MAKE) -f Makefile.st $(MDEFINES) $@; cd ..
	cd util; $(MAKE) -f Makefile.st $(MDEFINES) $@; cd ..
	cd texi2roff; $(MAKE) -f Makefile.st $(MDEFINES) $@; cd ..

realclean:
	cd libtxi; $(MAKE) -f Makefile.st $(MDEFINES) $@; cd ..
	cd makeinfo; $(MAKE) -f Makefile.st $(MDEFINES) $@; cd ..
	cd info; $(MAKE) -f Makefile.st $(MDEFINES) $@; cd ..
	cd util; $(MAKE) -f Makefile.st $(MDEFINES) $@; cd ..
	cd texi2roff; $(MAKE) -f Makefile.st $(MDEFINES) $@; cd ..

# Prevent GNU make v3 from overflowing arg limit on SysV.
.NOEXPORT:
