MAKEINFO(L)          ST Programmer's Manual          MAKEINFO(L)



NAME
     makeinfo - format texinfo files into files suitable for
     reading with GNU info.

SYNOPSIS
     makeinfo [ --no-validate ] [ --no-pointer-validate ]
     [ --no-warn ] [ --no-split ] [ --only-split ] [ --no-headers ]
     [ --no-number-footnotes ] [ --number-footnotes ] [ --verbose ]
     [ --version ] [ --output <name> ] [ --paragraph-indent <val>]
     [ --fill-column <val> ] [ --error-limit <val> ]
     [ -- reference-limit <val> ] [ --footnote-style <val> ]
     [ -I <DIR> ] [ -D <VAR> ] [ -U <VAR> ] [ -o <name> ] [ -f <val> ]
     [ -p <val> ] [ -e <val> ] [ -s <val> ] [ -f <val> ] [ -V ]
     file ...

DESCRIPTION
     Makefinfo reads texinfo file file and creates an output file
     suitable for reading with GNU info.  Default name for output
     is created from a basename by appending `.info' to it.  When
     output file is big enough and --no-split option was not
     specified then output is divided in smaller chunks and addi-
     tional names will have suffixes like `.info-1', `.info-2'
     and so on.  For systems where such long suffixes are not
     supported `info' string is dropped and extra suffixes are
     creates as `.-1', `.-2', ..., and so on.

OPTIONS
     Some options may have both long and short forms.  Here is a
     summary.

     -I   add <DIR> to the directory search list for including
          files with the `@include' command.

     -D   define variable <VAR>, as with `@set' command

     -U   undefine variable <VAR>, as with `@clear' command

     --no-validate
          suppres node cross reference validation.

     --no-pointer-validate
          synonymous with --no-validate

     --no-warn
          do not show warning messages (errors are still output).

     --no-split
          do not split resulting info file

     --only-split
          skip formatting and only split already formatted info
          file.  Input file has to have tags table in it.

     --no-headers
          do not write node headers, like `Node: Foo' to output
          file.

     --verbose
          be slightly more informative what you are doing

     --version,  -V
          print the version number of makeinfo

     --paragraph-indent <val>,  -p <val>
          set paragraph indent to <val>.  Accepted values are
          `none', `asis' or a number of spaces to indent.  Nega-
          tive values are treated as zero.  Default paragraph
          indent is 3 spaces.

     --fill-column <val>, -f <val>
          set fill column to <val>. Default column is 72.

     --error-limit <val>, -e <val>
          stop processing when <val> errors is reached.  Default
          is 100.

     --reference-limit <val>, -r <val>
          warn when some node was referenced too many times.
          Default is 1000.  o.IP "--footnote-style <style>, -s
          <style>" set style either to `separate' where footnotes
          are placed in their own node or to `end' (default)
          where footnotes are output at the bottom of a node in
          which they were defined.

     --number-footnotes
          automatically number footnotes that have no specified
          marker (default)

     --no-number-footnotes
          if no specified marker, mark footnotes with '*'.

     --output, -o
          specify name output file overriding `@setfilename' com-
          mand, if any.

SEE ALSO
     info(l), texindex(l)

BUGS
     All processing is done in memory so makeinfo may fail with
     bigger files when memory is limited.  If you got a failure
     after the first stage  you still can use --only-split option
     to split info file in a separate step.  This can be a pre-
     ferred course of action when a disk space may be not ample
     enough.  During an execution of both stages together mak-
     einfo needs an extra disk space of roughly double size of an
     original input.
