# Makefile for GNU info.  -*- Indented-Text -*-
# Atari ST version
# Copyright (C) 1993 Free Software Foundation, Inc.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


#### Start of system configuration section. ####

srcdir = .
VPATH = $(srcdir):$(common)

common = $(srcdir)/../libtxi

# Cross-compiler!
CC = cgcc
#CC = gcc
RM	= rm -f
STRIP   = #xstrip -k $@ # uncomment for a "production" version

DEFS =  -DSTDC_HEADERS=1
MSHORT = #-mshort
EXT = #16

LIBS = -L../libtxi -llibtxi$(EXT) -ltermcap$(EXT) -liio$(EXT)
LOADLIBES = $(LIBS)

#flags for version 2.x of gcc
CFLAGS = -O2 -Wall -fomit-frame-pointer -fstrength-reduce $(MSHORT)
LDFLAGS = -Xlinker -x
#CFLAGS = -g

# list of directories in which to look for info files.
PSEP = ,# this is for TOS - watch out for an extra space after separator
DEFAULT_INFOPATH = .$(PSEP)$(infodir)

# Command used to print out a text file.  The filename follows this command.
INFO_PRINT_COMMAND = lpr

# Where info files go.
infodir = c:\\gnu\\info

#### End of system configuration section. ####

PATHSPEC = -DDEFAULT_INFOPATH='"$(DEFAULT_INFOPATH)"'
PRINTSPEC = -DINFO_PRINT_COMMAND='"$(INFO_PRINT_COMMAND)"'
LDEFS = $(PATHSPEC) $(PRINTSPEC) -DHAVE_UNISTD_H -Dunix -DDOTS

SRCS = info.c
OBJS = info.o

PROGS = info.ttp

all: $(PROGS)

.c.o:
	$(CC) -c $(CPPFLAGS) $(LDEFS) $(DEFS) -I. -I$(srcdir) -I$(common) \
	$(CFLAGS) $<

$(PROGS): $(OBJS) ../libtxi/libtxi$(EXT).olb
	$(CC) $(LDFLAGS) -o $@ $(OBJS) $(LOADLIBES)
	$(STRIP)

info.o: info.c $(common)/getopt.h

clean:
	$(RM) *.o compile.err a.out core core.*

mostlyclean: clean

distclean: clean
	$(RM) $(PROGS)

realclean: distclean
	$(RM) TAGS

# Prevent GNU make v3 from overflowing arg limit on SysV.
.NOEXPORT:
