# Makefile for GNU texinfo/libtxi.  -*- Indented-Text -*-
# Atari-ST version
# Copyright (C) 1993 Free Software Foundation, Inc.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#### Start of system configuration section. ####

srcdir = .
VPATH = $(srcdir)

# these are for a cross-compiler
CC = cgcc
AR = cgcc-ar

RM	= rm -f

DEFS = -DGET_STRING_H -U__GNU_LIBRARY__ -Dmy_index=index -Dmy_bcopy=bcopy
LIBS = 
LOADLIBES = $(LIBS)

# Inherited from parent make.
#ALLOCA = @ALLOCA

MSHORT = #-mshort
EXT = #16

# In case you want to replace a library version
FINDFILE = findfile.o

CFLAGS = -O2 -fomit-frame-pointer -Wall $(MSHORT)

#### End of system configuration section. ####

SRCS =  getopt.c getopt.h getopt1.c findfile.c
OBJS =  getopt.o getopt1.o $(FINDFILE)

PROGS = libtxi$(EXT).olb

all: $(PROGS)

.c.o:
	$(CC) -c $(CPPFLAGS) -I. -I$(srcdir) $(DEFS) $(CFLAGS) $<

$(PROGS): clean $(OBJS)
	$(RM) $@
	$(AR) qcv $@ $(OBJS)

getopt.o: getopt.c getopt.h
getopt1.o: getopt1.c getopt.h
findfile.o: findfile.c
alloca.o: alloca.c

clean:
	$(RM) *.o a.out core core.*
realclean: clean
	$(RM) $(PROGS)

# Prevent GNU make v3 from overflowing arg limit on SysV.
.NOEXPORT:

# eof
