# Makefile for GNU makeinfo.  -*- Indented-Text -*-
# Atari ST version
# Copyright (C) 1993 Free Software Foundation, Inc.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#### Start of system configuration section. ####

srcdir = .
VPATH = $(srcdir):$(common)

common = $(srcdir)/../libtxi

CC = cgcc
#CC = gcc
RM	= rm -f
STRIP   = #xstrip -k $@ # uncomment for a "production" version

DEFS =  -DSTDC_HEADERS=1 -DHAVE_STRING_H=1 -DHAVE_SETVBUF=1 -DHAVE_BZERO=1 \
 -DHAVE_RINDEX=1 -DHAVE_VFPRINTF=1 -DHAVE_VSPRINTF=1

LDEFS = -DHAVE_SGTTY_H=1 -Dunix -DDOTS

#if '-mshort' used turn on definition of EXT
MSHORT = #-mshort
EXT = #16

LIBS = -L../libtxi -llibtxi$(EXT) -ltermcap$(EXT) -liio$(EXT)
LOADLIBES = $(LIBS)

#CFLAGS = -g -Wall
#LDFLAGS = -g
CFLAGS = -pipe -O2 -fomit-frame-pointer $(MSHORT) -Wall
LDFLAGS = $(CFLAGS) -Xlinker -x -v

# Comma-separated list of directories in which to look for info files.
DEFAULT_INFOPATH = .,$(infodir)

# Where info files go.
infodir = c:\\gnu\\info

#### End of system configuration section. ####

SRCS =  makeinfo.c
OBJS =  makeinfo.o

PROGS = makeinfo.ttp

all: $(PROGS) # makeinfo.info  # do not do that with cross-compiler
sub-all: all

.c.o:
	$(CC) -c $(CPPFLAGS) -I. -I$(srcdir) -I$(common) $(LDEFS) $(DEFS) \
	$(CFLAGS) $<

$(PROGS): $(OBJS) ../libtxi/libtxi$(EXT).olb
	$(CC) $(LDFLAGS) -o $@ $(OBJS) $(LOADLIBES)
	$(STRIP)

makeinfo.o: makeinfo.c $(common)/getopt.h

makeinfo.info: $(PROGS) makeinfo.texi
	./$(PROGS) --no-split -I$(srcdir) makeinfo.texi

clean:
	$(RM) *.o compile.err a.out core core.*

mostlyclean: clean

distclean: clean
	$(RM) $(PROGS)

realclean: distclean
	$(RM) TAGS
	$(RM) makeinfo.info

# Prevent GNU make v3 from overflowing arg limit on SysV.
.NOEXPORT:

# eof
