.TH INFO L "April 15, 1992"
.UC 4
.SH NAME
info \- display files formatted for use with with GNU info facility.
.SH SYNOPSIS
.B info
[
.B \--file <name>
] [
.B \--directory <dir>
] [
.B \--node <name>
] [
.B \--output <name>
] [
.B \--version
] [
.B \-f <name>
] [
.B \-d <dir>
] [
.B \-n <name>
] [
.B \-o <name>
] [
menu-selection ...
]
.br
.SH DESCRIPTION
Info formatted files are meant mainly for an info mode of GNU-emacs
which gives simple hypertext-like capabilities
for displaying on-line sizeable documents.
.I Info
provides most of it in a stand-alone program.  Files used with
.I info
have to be prepared either by emacs function texinfo-format-buffer
or by a companion
.I makeinfo
program.  An optional argument `menu-selection' should be a name
of one of menu entries in the first displayed node.
For help in using
.I info
see on-line help and info on-line tutorial.
.PP
.SH OPTIONS
All option flags have both long and short forms and are followed
by value strings.
.IP "--file <name>, -f <name>"
show named file.  If this option is missing
.I info
will try to start with a file named `dir'.  If full names are
not specified explicitely
.I info
tries to find files to read along path which can be specified
in an environment variable INFOPATH.  See below.
.IP "--directory <dir>, -d <dir>"
explicitely specify path to search for info files.  Path format follows usual
conventions for a specific OS.
.IP "--node <name>, -n <name>"
start with a given node.
.IP "--output <name>, -o <name>"
write a contents of the current node to a named file and exit.
.IP "--version"
print current version of
.I info
and exit.
.PP
.SH COMMANDS
The following keyboard commands are available when using
.I info.
.IP q
quit Info.
.IP \?
show on-line help.
.IP h
invoke
.I info
tutorial.
.IP n
move to the `next' node of this node.
.IP p
move to the `previous' node of this node.
.IP u
move `up' from this node.
.IP m
pick menu item specified by name.
Picking a menu item causes another node to be selected.
.IP f
follow a cross reference.  Reads name of reference.
.IP l
move to the last node you were at.
.IP d
move to the `directory' node.  Equivalent to `gDIR'.
.IP Space
scroll forward a page.
.IP DEL
scroll backward a page.
.IP b
go to the beginning of this node.
.IP 1
pick first item in node's menu.
.IP "2 - 5"
pick second ... fifth item in node's menu.
.IP g
move to node specified by name.
You may include a filename as well, as (FILENAME)NODENAME.
.IP (
read full node name in a form (FILENAME)NODENAME and move to it.
.IP s
search through this Info file for a specified string,
and select the node in which the next occurrence is found.
.IP "Ctl-P"
print the contents of this node
.PP
.SH "ENVIRONMENT VARIABLES"
.I Info reads the following environment variables.  When not
defined system defaults are used.
.IP "INFOPATH"
path to search for info files to read. Option -d overrides
this specification.
.IP "INFO_PRINT_COMMAND"
command to print nodes when `Ctl-P' key is used.
.PP
Apart of that variables TERM and TERMCAP or TERMINFO will
be used in a usual manner in order to determine characteristics
of a display screen.
.I Info
does not run if terminal capabilities are not sufficient.
.PP
.SH "SEE ALSO"
makeinfo(l), texindex(l)
.SH BUGS
Continuation search works as long as search string is not
modified and other commands are not called between searches.
Otherwise search is restarted at the top of the current node.
.PP
Enough memory is needed to read entirely the biggest displayed file.
