.TH MAKEINFO L "April 15, 1992"
.UC 4
.SH NAME
makeinfo \- format texinfo files into files suitable for reading with GNU info.
.SH SYNOPSIS
.B makeinfo
[
.B \--no-validate
] [
.B \--no-pointer-validate
] [
.B \--no-warn
] [
.B \--no-split
] [
.B \--only-split
] [
.B \--no-headers
] [
.B \--no-number-footnotes
] [
.B \--number-footnotes
] [
.B \--verbose
] [
.B \--version
] [
.B \--output <name>
] [
.B \--paragraph-indent <val>
] [
.B \--fill-column <val>
] [
.B \--error-limit <val>
] [
.B \--reference-limit <val>
] [
.B \--footnote-style <val>
] [
.B \-I <DIR>
] [
.B \-D <VAR>
] [
.B \-U <VAR>
] [
.B \-o <name>
] [
.B \-f <val>
] [
.B \-p <val>
] [
.B \-e <val>
] [
.B \-s <val>
] [
.B \-f <val>
] [
.B \-V
]
file ...
.br
.SH DESCRIPTION
.I Makefinfo
reads texinfo file
.I file
and creates an output file suitable for reading with GNU info.
Default name for output is created from a basename by appending
`.info' to it.  When output file is big enough and
.B \--no-split
option was not specified then output is divided in smaller chunks
and additional names will have suffixes like 
`.info-1', `.info-2' and so on.  For systems where such long
suffixes are not supported `info' string is dropped and extra
suffixes are creates as `.-1', `.-2', ..., and so on.
.PP
.SH OPTIONS
Some options may have both long and short forms.  Here is a
summary.
.IP -I <DIR>
add <DIR> to the directory search list for including files with
the `@include' command.
.IP -D <VAR>
define variable <VAR>, as with `@set' command
.IP -U <VAR>
undefine variable <VAR>, as with `@clear' command
.IP --no-validate
suppres node cross reference validation.
.IP --no-pointer-validate
synonymous with --no-validate
.IP --no-warn
do not show warning messages (errors are still output).
.IP --no-split
do not split resulting info file
.IP --only-split
skip formatting and only split already formatted info file.  Input
file has to have tags table in it.
.IP --no-headers
do not write node headers, like `Node: Foo' to output file.
.IP --verbose
be slightly more informative what you are doing
.IP "--version,  -V"
print the version number of
.I makeinfo
.IP "--paragraph-indent <val>,  -p <val>"
set paragraph indent to <val>.  Accepted values are `none', `asis'
or a number of spaces to indent.  Negative values are treated as zero.
Default paragraph indent is 3 spaces.
.IP "--fill-column <val>, -f <val>"
set fill column to <val>. Default column is 72.
.IP "--error-limit <val>, -e <val>"
stop processing when <val> errors is reached.  Default is 100.
.IP "--reference-limit <val>, -r <val>"
warn when some node was referenced too many times. Default is 1000.
o.IP "--footnote-style <style>, -s <style>"
set style either to `separate' where footnotes are placed in their
own node or to `end' (default) where footnotes are output at the
bottom of a node in which they were defined.
.IP --number-footnotes
automatically number footnotes that have no specified marker (default)
.IP --no-number-footnotes
if no specified marker, mark footnotes with '*'.
.IP "--output, -o"
specify name output file overriding `@setfilename' command, if any.
.SH "SEE ALSO"
info(l), texindex(l)
.SH BUGS
All processing is done in memory so makeinfo may fail with bigger
files when memory is limited.
If you got a failure after the first
stage  you still can use --only-split option to split info file
in a separate step.  This can be a preferred course of action
when a disk space may be not ample enough.  During an execution of both stages
together
.I makeinfo
needs an extra disk space of roughly double size of an original input.
