.TH TEXINDEX L "April 15, 1992"
.UC 4
.SH NAME
texindex \- create index files from raw indices created by TeX from
the first run on texinfo file.
.SH SYNOPSIS
.B texindex
[
.B \-o <name>
] [
.B \-k
]
file ...
.br
.SH DESCRIPTION
Running TeX typesetting program on texinfo file will usually
produce raw indices which have to be re-sorted and properly
re-formatted
for an inclusion of a final run of TeX.  This is done by
.I texindex
program.  Its input files by default will have names with
two letter suffixes so it is usually enough to use the command
in a form `texinfo *.??'.  This will create output files with
three letter suffixes derived by adding trailing `s'
and which be included in the next run of TeX automatically.
Using non-default names may require more work.
Giving to
.I texindex
a file which is not a raw index is supposed to be harmless.
.PP
.SH OPTIONS
The following options are available.
.IP "-o <name>"
store output in a named file.
.IP -k
keep intermediate results.
.SH "SEE ALSO"
tex(l), makeinfo(l).
.SH BUGS
When default names for input files are not used and OS
does not allow for more than three letters in file suffixes then
.I texinfo
tries hard to be smart about derived file names but a resulting
mess may need some untangling.
.PP
There is no check if a derived output file name does not conflict
with something already existing.  In such case it is assumed
that these are remains of the previous run of
.I texinfo
and they will be over-written with a new output.
