
# Makefile for Texinfo to nroff/troff translator (texi2roff)
# Atari ST version

#cross-compiler
CC = cgcc
#CC = gcc
RM = rm -f
STRIP = #xstrip -k $@ # uncomment for a "production" version

# Flags:
# -DBSD controls use of string(s).h and strchr/index only (not needed for Sun)
# use -Dvoid=int for System III and V7

LDEFS = -DBSD -DHAVE_UNISTD
MSHORT = #-mshort
EXT = #16

LIBS = -liio$(EXT)
LOADLIBES = $(LIBS)

# problems have been reported for -O with Sun4's, SunOS 4.0.1
CFLAGS = -O2 -fomit-frame-pointer -Wall $(MSHORT)
LDFLAGS= $(CFLAGS) -Xlinker -x -v


OBJS = texi2roff.o table.o translate.o items.o

PROGS = texi2roff.ttp

all: $(PROGS)

.c.o:
	$(CC) -c $(CPPFLAGS) $(LDEFS) $(DEFS) -I. -I$(srcdir) $(CFLAGS) $<

$(PROGS): $(OBJS)
	$(CC) -o $@ $(CFLAGS) $(LDFLAGS) $(OBJS) $(LIBS)
	$(STRIP)

texi2roff.o : texi2roff.h proto.h

translate.o : texi2roff.h  proto.h

table.o : texi2roff.h  proto.h tablems.h tablemm.h tableme.h 

items.o: texi2roff.h proto.h

clean:
	-$(RM) -f *.o compile.err

mostlyclean: clean

distclean: clean
	$(RM) $(PROGS)

realclean: distclean
	$(RM) TAGS

# Prevent GNU make v3 from overflowing arg limit on SysV.
.NOEXPORT:



