diff -ur texi2roff/items.c ./items.c
--- texi2roff/items.c	Mon Apr 12 17:41:07 1993
+++ ./items.c	Sat Apr 17 16:12:35 1993
@@ -21,10 +21,12 @@
 char item[MAXILEVEL][MAXLINELEN];
 
 extern int  ilevel;
+/**
 extern char * gettoken();
 extern char * eatwhitespace();
 extern void errormsg();
 extern struct tablerecd * lookup();
+**/
 
 /*
  * itemize - handle the itemizing start commands @enumerate, @itemize
diff -ur texi2roff/table.c ./table.c
--- texi2roff/table.c	Mon Apr 12 17:41:07 1993
+++ ./table.c	Sat Apr 17 16:07:59 1993
@@ -31,6 +31,7 @@
 
 struct misccmds * cmds;
 struct tablerecd * table, * endoftable;
+static void patchtable __PROTO((void));
 
 void
 initialize(macropkg, showInfo, makeindex)
@@ -38,7 +39,6 @@
 int showInfo;
 int makeindex;
 {
-    extern void patchtable();
     int tablesize;
 
     switch (macropkg) {
diff -ur texi2roff/texi2roff.c ./texi2roff.c
--- texi2roff/texi2roff.c	Mon Apr 12 17:41:08 1993
+++ ./texi2roff.c	Sat Apr 17 16:05:31 1993
@@ -23,6 +23,7 @@
  *	- initialize tables and other strings
  * 	- open files and pass them to process().
  */
+int
 main(argc, argv)
 int argc;
 char *argv[];
@@ -36,8 +37,11 @@
 
     extern int optind;
     extern char *optarg;
+#ifndef __STDC__
     extern int process();
     extern void initialize();
+    extern int getopt();
+#endif
 
     progname = argv[0];
 
@@ -109,7 +113,7 @@
 	    if (in != stdin)
 		(void) fclose(in);
 	}
-    exit(errflg);
+    return(errflg);
 }
 
 /*
@@ -122,7 +126,9 @@
     char *filename;
 {
     struct stat statbuf;
+#ifndef __STDC__
     extern int translate(/* FILE *, char * */);
+#endif
 
     if (fstat(fileno(fp), &statbuf) != 0){
 	(void) fprintf(stderr,"%s : can't fstat file %s\n", progname, 
diff -ur texi2roff/texi2roff.h ./texi2roff.h
--- texi2roff/texi2roff.h	Mon Apr 12 17:41:08 1993
+++ ./texi2roff.h	Sat Apr 17 16:11:33 1993
@@ -71,3 +71,10 @@
 #include <string.h>
 #endif
 
+#include <stdlib.h>
+#if HAVE_UNISTD
+#include <unistd.h>
+#else
+#include <libc.h>
+#endif
+#include "proto.h"
diff -ur texi2roff/translate.c ./translate.c
--- texi2roff/translate.c	Mon Apr 12 17:41:09 1993
+++ ./translate.c	Sat Apr 17 16:12:21 1993
@@ -19,6 +19,7 @@
 char	*filename;
 char 	*inp;			/* pointer into input buffer */
 
+#ifndef __STDC__
 extern struct tablerecd * lookup();
 
 /* forward references */
@@ -27,6 +28,7 @@
 extern char * itemize();
 extern char * doitem();
 extern char * interpret();
+#endif
 
 /*
  * errormsg - print error messages to stderr
@@ -158,7 +160,7 @@
     struct tablerecd *tptr;
     char	    *s, *cp, tempstr[MAXLINELEN],itemtag[MAXLINELEN];
     FILE	    *fp;	/* for @include files */
-    extern int	    process();	/* for @include files */
+    /* extern int	    process(); */	/* for @include files */
 
     if (init == NO) {
 	(void) strcpy(fontstack[0], defaultfont);
@@ -297,11 +299,13 @@
 		for (cp = tempstr; strchr(" \t\n",*s) == NULL; *cp++ = *s++)
 			;
 		*cp = '\0';
-		if (!discarding && ( fp = fopen(tempstr, "r")) == NULL)
-		    errormsg("can't open included file ", tempstr);
-		else {
-		    (void) process(fp, tempstr);
-		    (void) fclose(fp);
+		if (!discarding) {
+		    if (( fp = fopen(tempstr, "r")) == NULL)
+			errormsg("can't open included file ", tempstr);
+		    else {
+			(void) process(fp, tempstr);
+			(void) fclose(fp);
+		    }
 		}
 		break;
 	    default:
@@ -347,7 +351,7 @@
 	set_vec[0] = 1;
 	inited_set = 1;
 	}
-    while (set_vec[*str] == 0)
+    while (set_vec[(unsigned char)*str] == 0)
 	++str;
     return str;
 }
