#
# Makefile for utils for Atari TOS gcc
# - adjust CROSSDIR below for your setup if cross compiling otherwise
#   adjust CC
#
#
#CROSSDIR = /share/gcc-cross/atari
CROSSBIN = $(CROSSDIR)/bin
CROSSLIB = $(CROSSDIR)/lib
CROSSINC = $(CROSSDIR)/include

# Cross GCC
CC=$(CROSSBIN)/cgcc

CFLAGS = -O2 -fstrength-reduce -fomit-frame-pointer -Datarist -I.
LDFLAGS = -liio

#ALL = gcc-ld.ttp sym-ld.ttp gcc-nm.ttp gcc-ar.ttp gcc-size.ttp size68.ttp 
#      cnm.ttp fixstk.ttp printstk.ttp
ALL = gcc-ld.ttp gcc-nm.ttp gcc-ar.ttp gcc-size.ttp size68.ttp \
      cnm.ttp fixstk.ttp printstk.ttp xstrip.ttp sym-ld.ttp toglclr.ttp
all: $(ALL)

#
# the 'regular' linker, produces atari executables
#
gcc-ld.ttp : ld.o cplusdem.o
	$(CC) -o gcc-ld.ttp ld.o cplusdem.o $(LDFLAGS)

#
# the 'other' linker, produdes atari gdb compat symb files
#
sym-ld.ttp : sym-ld.o cplusdem.o
	$(CC) -o sym-ld.ttp sym-ld.o cplusdem.o $(LDFLAGS)

#
# symbol lister (NaMe list) gnu format only -- ie .o's and .olb's only
#
gcc-nm.ttp: nm.o cplusdem.o
	$(CC) -o gcc-nm.ttp nm.o cplusdem.o $(LDFLAGS)

# 
# Object file sizes (gnu format only) -- .o's and .olb's only
#
gcc-size.ttp: size.o
	$(CC) -o gcc-size.ttp size.o $(LDFLAGS)

#
# gcc-ar.ttp - archiver/librarian
#
gcc-ar.ttp : ar.o
	$(CC) -o gcc-ar.ttp ar.o $(LDFLAGS)

#
# show sizes of tos format executable
#
size68.ttp: size68.c
	$(CC) -O -o size68.ttp size68.c -s $(LDFLAGS)

#
# show symbols of tos format executable
# absolute minimal functionality.
#
cnm.ttp: cnm.c
	$(CC) -O -o cnm.ttp cnm.c $(LDFLAGS)

#
# print _stksize
#
printstk.ttp : printstk.c
	$(CC) -O -o printstk.ttp printstk.c -mshort -liio16

#
# fix _stksize
#
fixstk.ttp : fixstk.c
	$(CC) -O -o fixstk.ttp fixstk.c -mshort -liio16

#
# Strip symbols from TOS format executable
#
xstrip.ttp: strip.c
	$(CC) -O -o xstrip.ttp strip.c -mshort -liio16

#
# Manipulate TOS executable header  flags
#
toglclr.ttp: toglclr.c
	$(CC) -O -o toglclr.ttp toglclr.c -mshort -liio16

clean:
	rm -f *.o core

realclean: clean
	rm -f $(ALL)
